#ifndef CLIENTSOCKET_H
#define CLIENTSOCKET_H
#include "socket.h"


/**
 * Class ClientSocket
 * Specific Client Socket, all a client needs to communicate
 */
class ClientSocket : public Socket {
/**
 * Public stuff
 */
public:
	/**
	 * create a new general purpose Socket
	 * wrapper to ::socket()
	 */
	ClientSocket(const char* host, int port);
	
	/**
	 * Accessor Methods
	 */
	/**
	 * Operations
	 */
	/**
	 * connect to a server by using its domainname or ip-address and a port
	 */
	int connect (const char* hostname, int port);
	
	/**
	 * Connect to a server if we got a sockadd struct and the lenght
	 */
	int  connect (sockaddr* addr, int length);

	const ClientSocket& operator << ( const std::string& ) const;
	const ClientSocket& operator >> ( std::string& ) const;
};

#endif //CLIENTSOCKET_H

